; ============  ZX-16 =============
; 16-channel beeper for ZX Spectrum
;       created by: Jan Deak
;      FREEWARE - FREE SOURCE
; =================================
	ORG	32760
	
init	call start
	ld hl,#2758			;restore alternative HL to default value
	exx
	ret

start	DI
	CALL	kbl
	LD	HL,#CF00
	LD	(hbf),HL
	LD	E,0
jpx01	LD	(HL),E
	INC	HL
	BIT	5,H
	JR	Z,jpx01
	LD	HL,#AF00
jpx02	LD	(HL),E	
	INC	HL
	BIT	6,H
	JR	Z,jpx02
	LD	A,#74	 
	LD	(bt3+1),A
	LD	A,#6C	 
	LD	(bt1+1),A
	LD	(bt2+1),A
	LD	(bt10+1),A
	LD	(bt20+1),A
	LD	(bt11+1),A
	LD	(bt21+1),A
	LD	IY,trki
	LD	IX,chan
	LD	C,16
jp02	LD	L,(IY+0)
	LD	H,(IY+1)
	LD	(IX+0),L
	LD	(IX+1),H
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(IX+2),E
	LD	(IX+3),D
	PUSH	IX
	POP	DE
	INC	DE
	INC	DE
	INC	DE
	INC	DE
	LD	B,23
	XOR	A
jp03	LD	(DE),A
	INC	DE
	DJNZ	jp03
	LD	DE,31
	ADD	IX,DE
	INC	IY
	INC	IY
	DEC	C
	JP	NZ,jp02
	LD	C,#FE
	LD	HL,(hbf)
play0	LD	A,(hbf+1)
	XOR	#60
	NOP
	NOP
	OUTI
	LD	(hbf+1),A
	LD	A,(bt1+1)
	LD	(bt3+1),A
	XOR	#18
	NOP			
	NOP			
	OUTI
	LD	(bt1+1),A	
	LD	(bt2+1),A	
	LD	(bt10+1),A	
	LD	(bt20+1),A	
	OUTI
	LD	(bt11+1),A	
	LD	(bt21+1),A	
	LD	E,16		
	NOP			
	NOP			
	NOP			
	NOP			
	LD	A,0		
	OUTI
	LD	IX,chan		
	LD	E,16		
	LD	E,16		
	LD	IX,chan		 
	NOP			
	NOP			
	NOP			
jpr01	OUTI			
	LD	A,(IX+23)	
	OR	(IX+24)		 
	NOP			
	NOP			
	JP	Z,jpr02		
	OUTI
	EXX			
	NOP			
	LD	HL,(hbf)	
	LD	E,(IX+20)	
	EXX			
	NOP			
	OUTI
	EXX			
	LD	D,(IX+21)	 
	ADD	HL,DE		
	EXX			
	LD	B,0		
	LD	BC,#00FE	
	OUTI
	EXX			
	LD	E,(IX+23)	
	LD	D,(IX+24)	
	EXX			
	NOP			
	NOP			 
	OUTI
	LD	A,(IX+25)	
	LD	A,(IX+25)	
	OR	A		
	JP	Z,jpr10		   
	OUTI
	EXX			
	LD	C,A		
	RLCA			
	LD	A,0		
	SBC	A,0		
	LD	B,A		
	LD	A,(IX+19)	
	EXX			
	OUTI
	EXX			
	LD	C,0		
	NOP			
	LD	C,(IX+22)	 
	LD	C,(IX+22)	 
	EXX			
jpr03	OUTI			 
	EXX			
	ADD	A,C		
	LD	(HL),00		
	ADC	HL,DE		
	EX	AF,AF'		
	LD	A,C		
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	ADD	A,(IX+25) 	
	EX	DE,HL		
	LD	BC,0		
	ADC	HL,BC		
	EXX			
	OUTI
	EXX			
	LD	C,A		
	EX	DE,HL		
	LD	A,0		
	EX	AF,AF'		
	NOP			
	NOP			
bt1	BIT	5,H		
	EXX			
	JP	Z,jpr03		
	OUTI
	LD	IY,0		
	LD	IY,0		
	LD	IY,0		
	NOP			
	JP	jpr02		 
jpr10	OUTI			
	EXX			
	LD	B,0		
	LD	C,(IX+22)	
	EXX			
	LD	IY,0		
	NOP			
	NOP			
jpr11	OUTI
	EXX			
	NOP			
	LD	(HL),B		
	ADD	A,C		
	ADC	HL,DE		
bt10	BIT	5,H		
	EXX			
	JP	NZ,jpr02	 
	OUTI
	EXX			
	LD	(HL),B		
	ADD	A,C		
	ADC	HL,DE		
bt11	BIT	5,H		
	EXX			
	JP	Z,jpr11		
	NOP			
jpr02	OUTI			
	DEC	BC		
	LD	BC,31		 
	ADD	IX,BC		
	DEC	E		
	LD	C,#FE		
	JP	NZ,jpr01	
	OUTI
	LD	E,16		
	LD	IX,chan		
	LD	IX,chan		
	LD	A,(IX+4)	
jpa01	OUTI
	LD	A,(IX+4)	
	LD	IY,0		
	LD	B,255		
	OR	A		
	JP	NZ,jpa02	
jpa04	OUTI
	EXX			
	PUSH	IX		
	POP	HL		
	LD	DE,8		
	ADD	HL,DE		
	EXX			
	OUTI
	EXX			
	EX	DE,HL		
	LD	L,(IX+2)	 
	LD	H,(IX+3)	
	EXX			
	OUTI
	EXX			
	LDI			
	LDI			
	LDI			
	EXX			
	OUTI
	EXX			
	LDI			
	LD	A,(HL)		
	LD	(IX+4),A	
	INC	HL		
	EXX			
	OUTI
	LD	A,(IX+26)	
	LD	(IX+27),A	
	NOP			
	NOP			
	NOP			
	NOP			
	OUTI
	EXX			
	LD	A,(HL)		
	LD	(IX+26),A	
	LD	IY,0		
	INC	HL		
	EXX			
	OUTI
	EXX			
	LD	(IX+2),L	
	LD	(IX+3),H	
	NOP			
	EXX			
	OUTI
	LD	A,(IX+27)	
	LD	IY,0		
	CP	0		
	NOP			
	JP	Z,jnh01		
	OUTI
	EXX			
	LD	D,0		
	LD	HL,kmsk		
	DEC	A		
	LD	E,A		
	NOP			
	EXX			
	CP	64		
	JP	NC,jnh11	
	OUTI
	EXX				
	AND	1		
	LD	B,D		
	LD	C,A		
	ADD	HL,BC		
	LD	C,(HL)		
	LD	HL,#56C2	
	NOP			
	EXX			
	OUTI
	EXX			
	SRL	E		
	ADD	HL,DE		
	LD	A,(HL)		 
	AND	C		
	LD	(HL),A		
	NOP			
	NOP			
	EXX			
jnh01	OUTI
	LD	A,(IX+26)	
	LD	IY,0		
	CP	0		
	NOP			
	JP	Z,jnh02		
	OUTI
	EXX			
	LD	D,0		
	LD	HL,kmski	
	DEC	A		
	LD	E,A		
	NOP			
	EXX			
	CP	64		
	JP	NC,jnh12	
	OUTI
	EXX				
	AND	1		
	LD	B,D		
	LD	C,A		
	ADD	HL,BC		
	LD	C,(HL)		
	LD	HL,#56C2	
	NOP			
	EXX			
	OUTI
	EXX			
	SRL	E		
	ADD	HL,DE		
	LD	A,(HL)		 
	OR	C		
	LD	(HL),A		
	NOP			
	NOP			
	EXX			
jnh02	OUTI
	LD	A,E		
	ADD	A,A		
	ADD	A,A		
	LD	(IX+6),A	 
	XOR	A		
	LD	(IX+5),A	
	OUTI
	LD	(IX+7),A	
	LD	A,(IX+10)	
	NOP			
	NOP			
	NOP			
	NOP			
	OUTI
	JP	jpax1		
jpax1	NOP			
	NOP			
	CP	#FF		
	LD	A,(IX+4)	
	JP	NZ,jpa02	
	OUTI
	XOR	A		
	LD	(IX+4),A	
	EXX			
	LD	L,(IX+0)	
	NOP			
	EXX			
	OUTI
	EXX			
	LD	H,(IX+1)	
	INC	HL		
	INC	HL		
	EXX			
	NOP			
	NOP			
	LD	B,255		
	OUTI
	EXX			
	LD	(IX+0),L		
	LD	(IX+1),H	
	EXX			
	NOP			
	NOP			
	OUTI
	EXX			
	LD	E,(HL)		
	INC	HL		
	LD	D,(HL)		
	LD	(IX+2),E	
	EXX			
	LD	B,255		
	OUTI
	EXX			
	LD	(IX+3),D	
	LD	HL,1		
	EXX			
	NOP			
	NOP			
	LD	B,255		
	OUTI
	EXX			
	ADD	HL,DE		
	EXX			
	LD	B,255		
	LD	IY,0		
	NOP			
	JP	NC,jpa04	
xend	EI			
	RET
jpa02	OUTI
	DEC	A		
	LD	(IX+4),A	
	LD	(IX+4),A	
	NOP			
	NOP			
	NOP			
	OUTI
	LD	A,(IX+9)	
	OR	(IX+10)		
	NOP			
	NOP			
	JP	Z,jpnx2		
	OUTI
	EXX			
	LD	L,(IX+28)	
	LD	H,(IX+29)	
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	LD	E,(IX+30)	
	LD	A,(HL)		
	OR	E		
	LD	(HL),A		
	NOP			
	NOP			
	EXX			 
	OUTI
	EXX			
	NOP			
	LD	HL,(hbf)	
	LD	E,(IX+6)	
	EXX			
	NOP			
	OUTI
	EXX			
	LD	D,(IX+7)	
	ADD	HL,DE		
	EXX			
	LD	B,0		
	LD	BC,#00FE	
	OUTI
	EXX			
	LD	E,(IX+9)	
	LD	D,(IX+10)	
	EXX			
	NOP			
	NOP			 
	OUTI
	LD	A,(IX+11)	
	LD	A,(IX+11)	
	OR	A		
	JP	Z,jpn10		   
	OUTI
	EXX			
	LD	C,A		
	RLCA			 
	LD	A,0		
	SBC	A,0		
	LD	B,A		 
	LD	A,(IX+5)	
	EXX			
	OUTI
	EXX			
	LD	C,0		
	NOP			
	LD	C,(IX+8)	 
	LD	C,(IX+8)	 
	EXX			
jpn03	OUTI			 
	EXX			
	ADD	A,C		
	LD	(HL),#10	
	ADC	HL,DE		
	EX	AF,AF'		
	LD	A,C		
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	ADD	A,(IX+11) 	
	EX	DE,HL		
	LD	BC,0		
	ADC	HL,BC		
	EXX			
	OUTI
	EXX			
	LD	C,A		
	EX	DE,HL		
	LD	A,0		
	EX	AF,AF'		
	NOP			
	NOP			
bt2	BIT	5,H		
	EXX			
	JP	Z,jpn03		
	OUTI
	LD	IY,0		
	LD	IY,0		
	LD	IY,0		
	NOP			
	JP	jpn05		
jpn10	OUTI			
	EXX			
	LD	B,#10		
	LD	C,(IX+8)	
	EXX			
	LD	IY,0		
	NOP			
	NOP			
jpn11	OUTI
	EXX			
	NOP			
	LD	(HL),B		
	ADD	A,C		
	ADC	HL,DE		
bt20	BIT	5,H		
	EXX			
	JP	NZ,jpn05	
	OUTI
	EXX			
	LD	(HL),B		
	ADD	A,C		
	ADC	HL,DE		
bt21	BIT	5,H		
	EXX			
	JP	Z,jpn11		
	NOP			
jpn05	OUTI
	EXX			
	LD	C,A		
	LD	B,(IX+8)	
	PUSH	BC		 
	EXX			
	LD	IY,0		
	OUTI
	EXX			
	PUSH	DE		
	LD	A,H		 
	AND	#0F		
	LD	H,A		
	PUSH	HL		
	EXX			
	LD	B,255		
jpn02	OUTI
	EXX			
	PUSH	IX		
	POP	HL		
	LD	DE,18		
	ADD	HL,DE		
	EXX			
	OUTI
	EXX			
	LD	E,L		
	LD	D,H		
	INC	DE		
	INC	DE		
	INC	DE		
	INC	DE		
	INC	DE		
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	INC	DE		
	INC	DE		
	LDD			
	LDD			
	EXX			
	OUTI
	EXX			
	LDD			
	LDD			
	NOP			
	NOP			
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	LDD			
	LDD			
	LDD			
	EXX			
	OUTI
	EXX			
	LDD			
	LDD			
	NOP			
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	LDD			
	LDD			
	LDD			
	EXX			
	OUTI
	EXX			
	LDD			
	LDD			
	NOP			
	NOP			
	NOP			
	EXX			
	OUTI
	LD	A,(IX+9)	
	OR	(IX+10)		
	NOP			
	NOP			
	JP	Z,jpn04		
	OUTI
	EXX			
	POP	HL		
	POP	DE		
	POP	BC		
	EXX			
	NOP			
	NOP			
	NOP			
	NOP			
	OUTI
	EXX			
	LD	(IX+5),C	
	LD	(IX+6),L	
	EXX			
	NOP			
	NOP			
	OUTI
	EXX			
	LD	(IX+7),H	
	LD	(IX+8),B	
	EXX			
	NOP			
	NOP			
	OUTI
	EXX			
	LD	(IX+9),E	
	LD	(IX+10),D 	
	EXX			
	NOP			
	NOP			
jpn04	OUTI			
	DEC	BC		
	LD	BC,31		 
	ADD	IX,BC		
	DEC	E		
	LD	C,#FE		
	JP	NZ,jpa01	
	OUTI
	XOR	A		
	IN	A,(#FE)		
	OR	#E0		
	INC	A		
	JP	NZ,xend		
	NOP			
	LD	IY,0		
	OUTI
	EXX			
	LD	HL,(led)	
	LD	(#5380),HL	 
	LD	IY,0		
	EXX			
	OUTI
	EXX			
	LD	HL,(led+2)	
	LD	(#5580),HL	 
	LD	IY,0		
	EXX			
	OUTI
	LD	A,H		
	SUB	14		
	AND	#1F		
	EXX			
	LD	HL,perf		
	ADD	A,A		
	ADD	A,A		
	LD	E,A		
	LD	D,0		
	EXX			
	OUTI
	EXX			
	ADD	HL,DE		
	LD	DE,#539C	
	LDI			
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	LDI			
	LDI			
	LDI			
	EXX			
	OUTI
	LD	A,H		
	SUB	14		
	AND	#1F		
	EXX			
	LD	HL,perf		
	ADD	A,A		
	ADD	A,A		
	LD	E,A		
	LD	D,0		
	EXX			
	OUTI
	EXX			
	ADD	HL,DE		
	LD	DE,#559C	
	LDI			
	NOP			
	EXX			
	OUTI
	EXX			
	LDI			
	LDI			
	LDI			
	EXX			
	OUTI
	LD	A,H		
	SUB	14		
	AND	#1F		
	CP	#13		
	JP	NC,ovrn		
	LD	A,0		
	NOP			
	NOP			
jpn20	OUTI
	LD	IY,0		
	LD	IY,0		
	NOP			
	NOP			
bt3	BIT	6,H		 
	JP	Z,jpn20		
	OUTI
	LD	HL,(hbf)	
	JP	play0		 
jpnx2	OUTI
	EXX			
	LD	L,(IX+28)	
	LD	H,(IX+29)	
	NOP			
	NOP			
	EXX			
	OUTI
	EXX			
	LD	A,(IX+30)	
	XOR	#FF		
	AND	(HL)		
	LD	(HL),A		
	NOP			
	EXX			
	OUTI
	LD	IY,0		
	LD	IY,0		
	LD	IY,0		
	NOP			
	JP	jpn02		
jnh11	OUTI
	EXX				
	SUB	63		
	LD	E,A		
	AND	1		
	OR	2		
	LD	B,D		
	LD	C,A		
	ADD	HL,BC		
	LD	C,(HL)		
	EXX			
	OUTI
	EXX			
	LD	HL,#56A2	
	SRL	E		
	ADD	HL,DE		
	LD	A,(HL)		 
	OR	C		
	LD	(HL),A		
	EXX			
	OUTI
	EXX			
	LD	HL,0		
	LD	HL,0		
	LD	HL,0		
	NOP			
	EXX			
	JP	jnh01		
jnh12	OUTI
	EXX				
	SUB	63		
	LD	E,A		
	AND	1		
	OR	2		
	LD	B,D		
	LD	C,A		
	ADD	HL,BC		
	LD	C,(HL)		
	EXX			
	OUTI
	EXX			
	LD	HL,#56A2	
	SRL	E		
	ADD	HL,DE		
	LD	A,(HL)		 
	AND	C		
	LD	(HL),A		
	EXX			
	OUTI
	EXX			
	LD	HL,0		
	LD	HL,0		
	LD	HL,0		
	NOP			
	EXX			
	JP	jnh02		
kmsk	db	#07,#70,#C0,#0C
kmski	db	#70,#07,#3F,#F3
kbl	LD	HL,#5A80
	LD	A,#47		
	LD	B,#60
kbl1	LD	(HL),A
	INC	HL
	DJNZ	kbl1
	LD	HL,#4444
	LD	(#5A9C),HL
	LD	HL,#4246
	LD	(#5A9D),HL
	LD	HL,#0707
	LD	(#5ABB),HL
	LD	(#5ABC),HL
	LD	(#5ABE),HL
	LD	(#5ADB),HL
	LD	(#5ADC),HL
	LD	(#5ADE),HL
	LD	(#5AC0),HL
	LD	HL,#FFFF
	LD	(#56C0),HL
	LD	A,#FE
	LD	(#56DB),A
	LD	A,#7F
	LD	(#56DF),A
	LD	HL,#4242
	LD	(#5A80),HL	
	LD	C,8		
	LD	H,#50
	LD	A,#77
kbl2	LD	L,#C2
	LD	B,25
kbl02	LD	(HL),A
	INC	L
	DJNZ	kbl02
	INC	H
	DEC	C
	JP	NZ,kbl2
	LD	A,8		
	LD	D,#50
kbl3	LD	HL,kbsrb
	LD	E,#82
	LD	BC,25
	LDIR
	LD	E,#A2
	LD	HL,kbsrb
	LD	BC,25
	LDIR
	INC	D
	DEC	A
	JP	NZ,kbl3
	LD	HL,#56C2
	LD	A,#00		
	LD	B,25
kbl4	LD	(HL),A
	INC	HL
	DJNZ	kbl4
	LD	D,#56
	LD	HL,kbsrbl
	LD	E,#A2
	LD	BC,25
	LDIR
	LD	HL,nps
	LD	D,#52
kbl5	LD	E,#DC
	LD	BC,3
	LDIR
	INC	D
	LD	A,D
	CP	#57
	JP	NZ,kbl5
	RET
ovrn	LD	HL,#C4C4	 
	LD	(#5A9C),HL
	LD	HL,#C2C6
	LD	(#5A9E),HL
	JP	xend
led	db	#AA,#AA,#AA,#AA
kbsrb	DB	#62,#36,#22,#36,#23,#62,#23
	DB	#62,#36,#22,#36,#23,#62,#23
	DB	#62,#36,#22,#36,#23,#62,#23
	DB	#62,#36,#22,#37
kbsrbl	DB	#6E,#F6,#EE,#F6,#EF,#6E,#EF
	DB	#6E,#F6,#EE,#F6,#EF,#6E,#EF
	DB	#6E,#F6,#EE,#F6,#EF,#6E,#EF
	DB	#6E,#F6,#EE,#F7
nps	db	#FA,#20,#4E
	db	#11,#40,#D0 
	db	#20,#80,#5E
	db	#41,#40,#51
	db	#FA,#2F,#4E
perf	db	#A0,#00,#00,#00	
 	db	#A8,#00,#00,#00	
	db	#AC,#00,#00,#00	
	db	#AE,#00,#00,#00	
	db	#AF,#00,#00,#00	
	db	#AF,#80,#00,#00	
	db	#AF,#C0,#00,#00	
	db	#AF,#E0,#00,#00	
	db	#AF,#F0,#00,#00	
	db	#AF,#F8,#00,#00	
	db	#AF,#FC,#00,#00	
	db	#AF,#FE,#00,#00	
	db	#AF,#FF,#00,#00	
	db	#AF,#FF,#80,#00	
	db	#AF,#FF,#C0,#00	
	db	#AF,#FF,#E0,#00	
	db	#AF,#FF,#F0,#00	
	db	#AF,#FF,#F8,#00	
	db	#AF,#FF,#FC,#00	
	db	#AF,#FF,#FE,#00	
	db	#AF,#FF,#FF,#00	
	db	#AF,#FF,#FF,#80	
	db	#AF,#FF,#FF,#C0	
	db	#AF,#FF,#FF,#E0	
	db	#AF,#FF,#FF,#F0	
	db	#FF,#FF,#FF,#F8	
	db	#FF,#FF,#FF,#FC
	db	#FF,#FF,#FF,#FE
	db	#FF,#FF,#FF,#FF
hbf	DW	#A796	
chan	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led
	db	#80	
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led
	db	#20
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led
	db	#08
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led
	db	#02
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+1
	db	#80
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+1
	db	#20
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+1
	db	#08
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+1
	db	#02
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+2
	db	#80
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+2
	db	#20
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+2
	db	#08
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+2
	db	#02
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+3
	db	#80
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+3
	db	#20
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+3
	db	#08
	DW	0,0			
	DB	0,0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0,0,0,0,0,0		
	DB	0,0	
	DW	led+3
	db	#02
trki	DW	ch1,ch2,ch3,ch4
	DW	ch5,ch6,ch7,ch8
	DW	ch9,ch10,ch11,ch12
	DW	ch13,ch14,ch15,ch16
fend	DB	0,0,0      ;PAUSE
	DB	0,4,0
	DB	#FF,#FF,#FF	;END
	DB	0,0,0

;-----------------------------------------------
; DO NOT CHANGE ANYTHING BEFORE THIS LINE !!!
;-----------------------------------------------

; MUSIC DATA START 


;-----------------------------------
; CHANNELS WITH FRAME SEQUENCES
;-----------------------------------

; little demo with simple 4-chord melody, to show the features of ZX-16  
;musicdata
include "music.asm"
;include "music-bu-original.asm"
